<template>
    <div class="googleMap">
        <div ref="map" class="googleMap__container"></div>
    </div>
</template>

<script>

let zoom = {
    world: 1,
    city: 10,
    address: 17
}

export default {
    props: {
        placeId: {
            type: String,
            default: ''
        },
        zoom: {
            type: String,
            default: 'world',
            validator: function (value) {
                return Object.keys(zoom).indexOf(value) !== -1
            }
        }
    },
    watch: {
        placeId(){
            this.$loader.ensureReady()
                .then(() => {
                    return new Promise((resolve, reject) => {
                        let request = {
                            placeId: this.placeId,
                            fields: ['geometry']
                        }; 
                        
                        this.$service.getDetails(request, (place, status) => {
                            if (status == google.maps.places.PlacesServiceStatus.OK) {
                                resolve(place)
                            }
                            reject()
                        });
                    })
                })
                .then(place => {
                    this.$marker.setVisible(true)
                    this.$marker.setPosition(place.geometry.location)
                    this.$marker.setAnimation(window.google.maps.Animation.BOUNCE)
                    setTimeout(()=>this.$marker.setAnimation(null), 200)
                    this.$map.panTo(place.geometry.location)
                    this.$map.setZoom(zoom[this.zoom])
                })
                .catch(error => {
                    this.$marker.setVisible(false)
                })
        },
        zoom(){
            this.$loader.ensureReady()
                .then(() => {
                    this.$map.setZoom(zoom[this.zoom])
                })
        }
    },
    mounted(){
        this.$loader.ensureReady()
            .then(() => {
                this.$map = new window.google.maps.Map(this.$refs.map, {
                    center: {lat: -33.866, lng: 151.196},
                    zoomControl: true,
                    mapTypeControl: false,
                    scaleControl: true,
                    streetViewControl: false,
                    rotateControl: false,
                    fullscreenControl: true,
                    zoom: zoom[this.zoom]
                })

                this.$marker = new google.maps.Marker({
                    position: {lat: -33.866, lng: 151.196},
                    map: this.$map,
                    visible: false,
                    animation: google.maps.Animation.DROP
                })

                this.$service = new google.maps.places.PlacesService(this.$map);
            })
    }
}
</script>

<style>
    .googleMap__container{
        height: 300px;
        width: 100%;
    }
</style>
